<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta http-equiv="X-UA-Compatible" content="ie=edge">
    <title>Tabellenkalkulation</title>
    <style>
        *{box-sizing: border-box}

        table {
            border-collapse: collapse;
            border-spacing: 0;
        }

        td {
            border: 1px solid black;
            min-width: 90px;
            height: 30px;
            text-align: center;
        }
    </style>
</head>
<body>
    <h1>Tabellenkalkulation<br>mit contentEditable</h1>
    <table></table>

    <script>
        const table = document.querySelector('table');   
        
        const getCellByLetterAndKoordinate = function(column, row)
        {
            var charCode = column.charCodeAt(0);
            return getCellByKoordinates(charCode <= 90 ? charCode - 64 : charCode - 96, row);
        }

        const getCellByKoordinates = function(column, row)
        {
            var rowNum = parseInt(row)+1;
            var columnNum = parseInt(column)+1;

            if(columnNum < 2)
            {
                columnNum = MAX_COLS;
                rowNum = rowNum - 1;
            }
            
            if(columnNum > MAX_COLS)
            {
                columnNum = 2;
                rowNum = rowNum + 1;
            }

            if(rowNum < 2)
                rowNum = MAX_ROWS;

            if(rowNum > MAX_ROWS)
                rowNum = 2;

            return document.querySelector("table tr:nth-child(" + rowNum + ") td:nth-child(" + columnNum + ")");
        }

        const getCellValue = function (input)
        {
            var re = /^([a-z])(\d+)$/i;
            var matches = input.match(re);
            if(matches != null)
            {
                const refcell = getCellByLetterAndKoordinate(matches[1], matches[2]);
                if(refcell != null)
                {
                    return refcell.innerHTML;
                }
            }
            return null;
        }

        const getSkalarValue = function(input)
        {
            console.log("getSkalarValue " + input);
            var re = /^-?\d+$/i;
            if(input.match(re))
                return input;            
            return null;
        }

        const getBinaryFuncOfOperand = function(input)
        {
            console.log("getBinaryFuncOfOperand " + input);
            const parse = function(input)
            {
                return parseFloat(input);
            }
            if(input.toUpperCase().match(/^SUM$/) || input.match(/^\+$/))
                return function(op)
                {
                    var result = 0;
                    op.forEach(element => {
                        result += parse(element);
                    });
                    return result;
                }
            if(input.toUpperCase().match(/^MUL$/) || input.match(/^\*$/))
                return function(op)
                {
                    var result = 1;
                    op.forEach(element => {
                        result *= parse(element);
                    });
                    return result;
                }
            if(input.toUpperCase().match(/^SUB$/) || input.match(/^\-$/))
                return function(op)
                {
                    var result = 0;
                    op.forEach(element => {
                        result -= parse(element);
                    });
                    return result;
                }
            if(input.toUpperCase().match(/^DIV$/) || input.match(/^\/$/))
                return function(op)
                {
                    var result = 1;
                    op.forEach(element => {
                        result /= parse(element);
                    });
                    return result;
                }
            if(input.toUpperCase().match(/^MOD$/) || input.match(/^\%$/))
                return function(op)
                {
                    var result = 0;
                    op.forEach(element => {
                        result %= parse(element);
                    });
                    return result;
                }
            
            return null;
        }



        const calcOperator = function(input)
        {
            // Operator as a function
            var re = /^([a-z]{3,10})\s*\(\s*(.+)\s*[\;\,]\s*(.+)\s*\)$/i;
            var value = calcOperatorWithRegex(input, re, 1, 2, 3);
            if(value != null)
                return value;

            // Operator as a single sign
            re = /^((\w+\.?\w*)\s*([\+\-\*\/\%])\s*)*(\w+\.?\w*)$/i;
            value = calcOperatorWithRegex(input, re, 3, 2, 4);
            if(value != null)
                return value;
            return null;
        }
        
        const calcOperatorWithRegex = function(input, re, operatorindex, operand1, operand2)
        {
            var matches = input.match(re);
            if(matches)
            {
                var func = getBinaryFuncOfOperand(matches[operatorindex]);
                if(func != null)
                {
                    var op1 = calculate(matches[operand1]);
                    var op2 = calculate(matches[operand2]);
                    if(op1 != null && op2 != null)
                        return func([op1, op2]);
                }
            }
            return null;
        }

        const calculateValue = function(input)
        {
            console.log("calculateValue " + input);
            var value = getSkalarValue(input);
            if(value != null)
                return value;            
            value = getCellValue(input);
            if(value != null)
                return value;
            return null;
        }

        const calculate = function(input)
        {
            console.log("calculate " + input);
            if(input === '')
                return "";            
            var value = calculateValue(input);
            if(value != null)
                return value;
            value = calcOperator(input);
            if(value != null)
                return value;
            return "#ERROR";
        }        

        const focusListener = function()
        {
            const calculation = this.getAttribute('calculation');
            if(calculation != 'null')
                this.innerHTML = calculation;
        }
        
        const recalculateAll = function()
        {
            const cells = document.querySelectorAll('td[calculation]');
            for(i = 0; i < cells.length; i++)
            {                
                const cell = cells[i];
                const value = cell.getAttribute('calculation');
                if(value != 'null' && value.startsWith("="))
                {
                    var modvalue = value.replace(/^=/i, '');
                    modvalue = modvalue.replace(/<br>/i, '');
                    cell.innerHTML = calculate(modvalue);
                }
            }
        }

        const blurListener = function()
        {
            const value = this.innerHTML;
            this.setAttribute('calculation', value);
            recalculateAll();
        }

        const MAX_ROWS = 100;
        const MAX_COLS = 27;

        // page init
        for (i = 0; i < MAX_ROWS; i++)
        {            
            const row = document.createElement('tr');
            table.appendChild(row);
            
            for (j = 0; j < MAX_COLS; j++)
            {
                const cell = document.createElement('td');
                row.appendChild(cell);
                
                // style information for header row/column
                if(i === 0 || j === 0)
                {
                    cell.style.fontWeight = 'bolder';
                    cell.style.borderWidth = "2px";
                }
                // contenteditable for all other cells
                else
                {
                    cell.contentEditable = true;
                    cell.setAttribute('calculation', null);
                    cell.setAttribute('column', j);
                    cell.setAttribute('row', i);
                    cell.onblur = blurListener;
                    cell.onfocus = focusListener;
                }

                // content for header row/column
                if(i === 0 && j > 0)
                    // since A = 65 and the 0 column is empty
                    cell.innerHTML = String.fromCharCode(64 + j);
                if(i > 0 && j === 0)
                    cell.innerHTML = i;

                // enter should not open a div in the cell
                cell.onkeydown = (event) =>
                {
                    var column = parseInt(cell.getAttribute('column'));
                    var row = parseInt(cell.getAttribute('row'))       
                    if (event.key === 'Enter')
                        cell.blur();            

                    if(event.key === 'ArrowUp')
                    {
                        const nextCell = getCellByKoordinates(column, row-1);
                        nextCell.focus();
                    }
                    if(event.key === 'ArrowDown')
                    {
                        const nextCell = getCellByKoordinates(column, row+1);
                        nextCell.focus();
                    }
                }
            }            
        }
    </script>
</body>
</html>
